﻿
using ProjectDumpTruck.Entities;

namespace ProjectDumpTruck.Drawnings;


/// <summary>
/// Сравнение по цвету, скорости и весу
/// </summary>
public class DrawningTruckCompareByColor : IComparer<DrawningTruck?>
{
    public int Compare(DrawningTruck? x, DrawningTruck? y)
    {
        if (x == null || x.EntityTruck == null)
        {
            return 1;
        }
        if (y == null || y.EntityTruck == null)
        {
            return -1;
        }
        var bodyColorCompare = y.EntityTruck.BodyColor.Name.CompareTo(x.EntityTruck.BodyColor.Name);
        if (bodyColorCompare != 0)
        {
            return bodyColorCompare;
        }
        if (x is DrawningDumpTruck && y is DrawningDumpTruck)
        {
            var additionalColorCompare = (y.EntityTruck as EntityDumpTruck).AdditionalColor.Name.CompareTo(
                (x.EntityTruck as EntityDumpTruck).AdditionalColor.Name);
            if (additionalColorCompare != 0)
            {
                return additionalColorCompare;
            }
        }
        var speedCompare = y.EntityTruck.Speed.CompareTo(x.EntityTruck.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return y.EntityTruck.Weight.CompareTo(x.EntityTruck.Weight);
    }
}
