﻿namespace ProjectDumpTruck.Drawnings;

/// <summary>
/// Сравнене по типу, скорости, весу
/// </summary>
public class DrawningTruckCompareByType : IComparer<DrawningTruck?>
{
    public int Compare(DrawningTruck? x, DrawningTruck? y)
    {
        if (x == null || x.EntityTruck == null)
        {
            return 1;
        }
        if (y == null || y.EntityTruck == null)
        {
            return -1;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return y.GetType().Name.CompareTo(x.GetType().Name);
        }
        var speedCompare = y.EntityTruck.Speed.CompareTo(x.EntityTruck.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return y.EntityTruck.Weight.CompareTo(x.EntityTruck.Weight);
    }
}

