﻿using ProjectDumpTruck.Entities;
using System.Diagnostics.CodeAnalysis;

namespace ProjectDumpTruck.Drawnings;

public class DrawningTruckEqutables : IEqualityComparer<DrawningTruck?>
{
    public bool Equals(DrawningTruck? x, DrawningTruck? y)
    {
        if (x == null || x.EntityTruck == null)
        {
            return false;
        }
        if (y == null || y.EntityTruck == null)
        {
            return false;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }
        if (x.EntityTruck.Speed != y.EntityTruck.Speed)
        {
            return false;
        }
        if (x.EntityTruck.Weight != y.EntityTruck.Weight)
        {
            return false;
        }
        if (x.EntityTruck.BodyColor != y.EntityTruck.BodyColor)
        {
            return false;
        }
        if (x is DrawningDumpTruck && y is DrawningDumpTruck)
        {
            // TODO доделать логику сравнения дополнительных параметров
            if ((x.EntityTruck as EntityDumpTruck)?.AdditionalColor !=
                (y.EntityTruck as EntityDumpTruck)?.AdditionalColor)
            {
                return false;
            }
            if ((x.EntityTruck   as EntityDumpTruck)?.Awning !=
                (y.EntityTruck as EntityDumpTruck)?.Awning)
            {
                return false;
            }
            if ((x.EntityTruck   as EntityDumpTruck)?.Tent !=
                (y.EntityTruck as EntityDumpTruck)?.Tent)
            {
                return false;
            }
        }
        return true;
    }

    public int GetHashCode([DisallowNull] DrawningTruck? obj)
    {
        return obj.GetHashCode();
    }
}
